// Proposed by Peter Welch in e-mail to me on 29Jan98
// Programmed by yvind Teig

// Both A,B and C get the resource

// We have the same behaviour with
// 1. Symantec Java! JustInTime Compiler Version 210.063 for JDK 1.1.3
//    Copyright (C) 1996-97 Symantec Corporation
//    Running on Window-95
// 2. JVM 1.1.5
//    Running on Window-95

//{{{  Resource
class Resource {
   public synchronized void take (String id) {
      System.out.println ("User " + id + " has resource");
      try {Thread.sleep(3000);} catch (InterruptedException e){}
   }
}
//}}}  
//{{{  User
class User extends Thread {
   private String id;
   private Resource resource;

   public User (String id, Resource resource) {
      this.id = id;
      this.resource = resource;
      System.out.println ("User " + id + " started");
      start();
   }

   public void run() {
      while (true) {
         resource.take(id);
         try {Thread.sleep(1000);} catch (InterruptedException e){}
      }
   }
}
//}}}  

class TakeResource {
   //{{{  main
   public static void main (String argv[]) {
      Resource resource = new Resource();

      User[] user = new User[3];

      user[0] = new User ("A  ", resource);
      try {Thread.sleep(1000);} catch (InterruptedException e){}
      user[1] = new User (" B ", resource);
      try {Thread.sleep(1000);} catch (InterruptedException e){}
      user[2] = new User ("  C", resource);
   }
   //}}}  
}
